package com.yeejoin.precontrol.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yeejoin.precontrol.common.entity.TaskPersonFeedback;
import com.yeejoin.precontrol.common.service.ITaskPersonFeedbackService;
import com.yeejoin.precontrol.common.utils.NameUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.util.ReflectionUtils;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Arrays;

/**
 * 人员反馈表
 *
 * @author duanwei
 * @date 2020-12-08
 */
@RestController
@Api(tags = "人员反馈表Api")
@RequestMapping(value = "/task-person-feedback", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
public class TaskPersonFeedbackController {

	@Autowired
	ITaskPersonFeedbackService iTaskPersonFeedbackService;

	/**
	 * 新增人员反馈表
	 * 
	 * @return
	 */
	@RequestMapping(value = "/save", method = RequestMethod.POST)
	@ApiOperation(httpMethod = "POST", value = "新增人员反馈表", notes = "新增人员反馈表")
	public boolean saveTaskPersonFeedback(HttpServletRequest request,
			@RequestBody TaskPersonFeedback taskPersonFeedback) {
		return iTaskPersonFeedbackService.saveFeedBack(taskPersonFeedback);
	}

	/**
	 * 根据id删除
	 * 
	 * @param id
	 * @return
	 */
	@RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
	@ApiOperation(httpMethod = "DELETE", value = "根据id删除", notes = "根据id删除")
	public boolean deleteById(HttpServletRequest request, @PathVariable Long id) {
		return iTaskPersonFeedbackService.removeById(id);
	}

	/**
	 * 修改人员反馈表
	 * 
	 * @return
	 */
	@RequestMapping(value = "/updateById", method = RequestMethod.PUT)
	@ApiOperation(httpMethod = "PUT", value = "修改人员反馈表", notes = "修改人员反馈表")
	public boolean updateByIdTaskPersonFeedback(HttpServletRequest request,
			@RequestBody TaskPersonFeedback taskPersonFeedback) {
		return iTaskPersonFeedbackService.updateById(taskPersonFeedback);
	}

	/**
	 * 根据id查询
	 * 
	 * @param id
	 * @return
	 */
	@RequestMapping(value = "/{id}", method = RequestMethod.GET)
	@ApiOperation(httpMethod = "GET", value = "根据id查询", notes = "根据id查询")
	public TaskPersonFeedback selectById(HttpServletRequest request, @PathVariable Long id) {
		return iTaskPersonFeedbackService.getById(id);
	}

	/**
	 * 列表分页查询
	 * 
	 * @return
	 */
	@RequestMapping(value = "/list", method = RequestMethod.GET)
	@ApiOperation(httpMethod = "GET", value = "列表分页查询", notes = "列表分页查询")
	public IPage<TaskPersonFeedback> listPage(String pageNum, String pageSize, TaskPersonFeedback taskPersonFeedback) {

		Page<TaskPersonFeedback> pageBean;
		QueryWrapper<TaskPersonFeedback> taskPersonFeedbackQueryWrapper = new QueryWrapper<>();
		Class<? extends TaskPersonFeedback> aClass = taskPersonFeedback.getClass();
		Arrays.stream(aClass.getDeclaredFields()).forEach(field -> {
			try {
				ReflectionUtils.makeAccessible(field);
				Object o = field.get(taskPersonFeedback);
				if (o != null) {
					Class<?> type = field.getType();
					String name = NameUtils.camel2Underline(field.getName());
					if (type.equals(Integer.class)) {
						Integer fileValue = (Integer) field.get(taskPersonFeedback);
						taskPersonFeedbackQueryWrapper.eq(name, fileValue);
					} else if (type.equals(Long.class)) {
						Long fileValue = (Long) field.get(taskPersonFeedback);
						taskPersonFeedbackQueryWrapper.eq(name, fileValue);
					} else if (type.equals(String.class)) {
						String fileValue = (String) field.get(taskPersonFeedback);
						taskPersonFeedbackQueryWrapper.eq(name, fileValue);
					} else {
						String fileValue = (String) field.get(taskPersonFeedback);
						taskPersonFeedbackQueryWrapper.eq(name, fileValue);
					}
				}
			} catch (Exception e) {
			}
		});
		IPage<TaskPersonFeedback> page;
		if (StringUtils.isBlank(pageNum) || StringUtils.isBlank(pageSize)) {
			pageBean = new Page<>(0, Long.MAX_VALUE);
		} else {
			pageBean = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
		}
		page = iTaskPersonFeedbackService.page(pageBean, taskPersonFeedbackQueryWrapper);
		return page;
	}
}
